// SampleOpenGL.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "SampleOpenGL.h"
#include "../../../../../cvs-local/research/code/vc6/alpha1/src/blepo.h"  // you must include blepo.h before including FigureGlut.h
#include "FigureGlut.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace blepo;

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		return 1;
	}

  try
  {
    MyFigureGlut mfg("3D model -- use mouse to navigate, ESC to quit", 500, 500);

    // load points and convert to 'ColoredPoint' data structure
    MatDbl pnts;
    Load("truck.ply",&pnts);
    std::vector<MyFigureGlut::ColoredPoint> cp;
    assert( pnts.Width() >= 9 );
    for (int i=0 ; i<pnts.Height() ; i++)  
    {
      float x = pnts(0, i);
      float y = pnts(1, i);
      float z = pnts(2, i);
      unsigned char r = pnts(6, i);  //Only for PMVS files that have 9 values for each point
      unsigned char g = pnts(7, i);
      unsigned char b = pnts(8, i);
      cp.push_back( MyFigureGlut::ColoredPoint( x, y, z, blepo::Bgr(b, g, r) ) ); 
    }
    mfg.SetPoints( cp );

    mfg.EnterMainLoop();
  } catch (Exception& e)
  {
    e.Display();
  }

	return 0;
}


